#include	<stdio.h>
#ifndef	NO_STRING_H
#include	<string.h>
#endif
#ifdef	HAVE_UNISTD_H
#include	<unistd.h>
#endif
#ifndef	NO_FCNTL_H
#include	<fcntl.h>
#endif
#include	<sys/stat.h>
#include	"thread.h"

#define	OPEN	_gzip_open
#define	CREATE	_gzip_create
extern int _gzip_open(char*, int);
extern int _gzip_create(char*, int);
extern int (*_gzip_work)(int, int);

#ifndef	SLAVE_STACK_SIZE
#define	SLAVE_STACK_SIZE	0x1000
#endif	/*SLAVE_STACK_SIZE*/

#define	biased(fd)	(fd+_THREAD_BIAS_)
#define	realized(fd)	(fd-_THREAD_BIAS_)

#ifdef	__STDC__
#define	PTR	void*
#define	CONST	const
#else
#define	PTR	char*
#define	CONST
#endif

#ifdef	DEBUG
#define	STATIC
#else
#define	STATIC	static
#endif

STATIC int	slave_stack[SLAVE_STACK_SIZE];

#ifdef	CHECK_THREAD_BUSY
STATIC int	thread_busy = 0;
#endif
STATIC int*	main_sp;
STATIC int*	slave_sp = slave_stack + SLAVE_STACK_SIZE;

STATIC volatile long	main_lseek_pos = 0L;
STATIC volatile int		main_cnt;
STATIC volatile char*	main_ptr;
STATIC volatile int		slave_fd;
STATIC volatile int		slave_siz;
STATIC volatile int		slave_cnt;
STATIC volatile char*	slave_ptr;

STATIC int	slave_started;

static void dispatch_to_main(void);
static void dispatch_to_slave(void);
static void slave_read_start(void);
static void slave_write_start(void);


int	_thread_open(char* file, int mode)
{
	int	fd;
	extern int (_gzip_unzip)(int, int);

#ifdef	DEBUG
	fprintf(stderr, "%20s(file=\"%s\", mode=%x)\n", "_thread_open", file, mode);
	fprintf(stderr, "stack master=%06x, slave=%06x(%06x-%06x)\n",
			main_sp, slave_sp, slave_stack, slave_stack + SLAVE_STACK_SIZE);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

#ifdef	CHECK_THREAD_BUSY
	/* ɌĂяoĂȂ`FbN */
	if (thread_busy) return -1;
	thread_busy = 1;
#endif

	/* ݂͂łȂ */
	if (mode & (O_WRONLY|O_RDWR)) {
		if ((mode & O_RDONLY) == 0) return _thread_create(file, mode);
		return -1;
	}

	/* ϐ̏ */
	slave_started = 0;
	main_lseek_pos = 0L;
	slave_ptr = main_ptr = 0;
	slave_cnt = main_cnt = 0;
	slave_sp = slave_stack + SLAVE_STACK_SIZE;
	_gzip_work = _gzip_unzip;
#ifdef	DEBUG
	{
		int	i;
		for (i = SLAVE_STACK_SIZE; --i >= 0; slave_stack[i] = 0);
	}
#endif

	/* ǂݍ݂݂̂ƃoCi[h̐ݒ */
	fd = OPEN(file, O_RDONLY | O_BINARY);

	return (fd == -1 ? -1 : biased(fd));
}


int	_slave_write(int fd, char* buf, size_t siz)
{
#ifdef	DEBUG
	fprintf(stderr, "%20s(fd=%x, buf=%p, siz=%d(%x))\n", "_slave_write", fd, buf, siz, siz);
	fprintf(stderr, "stack master=%06x, slave=%06x\n", main_sp, slave_sp);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

	/* Xbht@CfBXNv^ */
	if (!_isthread(fd)) return -1;

	slave_ptr = buf;
	if ((slave_siz = slave_cnt = siz) == 0) {

		/* ނׂf[^Ȃ̂Ő main ɖ߂ */
		dispatch_to_main();
		return 0;
	}

	while (slave_cnt > 0) {

		/* ޗ]nf[^Ȃ */
		if (slave_cnt < main_cnt) {
			memcpy((PTR)main_ptr, (CONST PTR)slave_ptr, slave_cnt);
			main_ptr += slave_cnt;
			main_cnt -= slave_cnt;	/* main_cnt > 0 ɐ藧 */

			/* ēxX[u𓮂 */
			return siz;
		}

		/* main  block Ăꏊɖ߂ */
		dispatch_to_main();

	}

	/* ēxX[u𓮂 */
	return siz;
}


static void	slave_read_main()
{
	(*_gzip_work)(slave_fd, biased(slave_fd));
	for (;;) {
		_slave_write(biased(slave_fd), (char*)0, 0);
	}
}


int	_thread_read(int fd, char* buf, int siz)
{
#ifdef	DEBUG
	fprintf(stderr, "%20s(fd=%x, buf=%p, siz=%d(%x))\n", "_thread_read", fd, buf, siz, siz);
	fprintf(stderr, "stack master=%06x, slave=%06x\n", main_sp, slave_sp);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

	/* Xbht@CfBXNv^ */
	if (!_isthread(fd)) return -1;

	/* 0 oCgǂݍ݂͏ɐ */
	if (siz == 0) return 0;

	/* V[N|C^i߂ */
	main_lseek_pos += (long)siz;

	/* f[^ɕϊ */
	main_ptr = buf;
	main_cnt = siz;

	/* X[u͋Nς */
	if (slave_started == 0) {

		/* slave N */
		slave_started = 1;
		slave_fd = realized(fd);
		slave_read_start();

		/* slave_cnt <= 0 ȂΈُI */
		if (slave_cnt < 0) return -1;

		/* X[u̓dĂт */
		if (slave_cnt == 0) return siz - main_cnt;
	}

	do {
		/* ǂݍނׂf[^obt@ɂ邩 */
		if (slave_cnt > 0) {

			/* vʂobt@f[^ʂ */
			if (slave_cnt >= main_cnt) {
				memcpy((PTR)main_ptr, (CONST PTR)slave_ptr, main_cnt);
				slave_ptr += main_cnt;
				slave_cnt -= main_cnt;
				return siz;
			}

			/* obt@f[^Rs[(obt@͋ɂȂ) */
			memcpy((PTR)main_ptr, (CONST PTR)slave_ptr, slave_cnt);
			main_ptr += slave_cnt;
			main_cnt -= slave_cnt;	/* main_cnt > 0 ɐ藧 */
			slave_cnt = 0;
		}

		/* thread  block Ăꏊɖ߂ */
		dispatch_to_slave();

	} while (slave_cnt > 0);

	/* ǂݍ񂾃TCYԂ */
	return siz - main_cnt;
}


int	_thread_create(char* file, int mode)
{
	int	fd;
	extern int (_gzip_zip)(int, int);

#ifdef	DEBUG
	fprintf(stderr, "%20s(file=\"%s\", mode=%x)\n", "_thread_create", file, mode);
	fprintf(stderr, "stack master=%06x, slave=%06x(%06x-%06x)\n",
			main_sp, slave_sp, slave_stack, slave_stack + SLAVE_STACK_SIZE);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

#ifdef	CHECK_THREAD_BUSY
	/* ɌĂяoĂȂ`FbN */
	if (thread_busy) return -1;
	thread_busy = 1;
#endif

	/* ǂݍ݂݂̂͂łȂ */
	if (mode & O_RDONLY) return -1;

	slave_started = 0;
	main_lseek_pos = 0L;
	slave_ptr = main_ptr = 0;
	slave_cnt = main_cnt = 0;
	slave_sp = slave_stack + SLAVE_STACK_SIZE;
	_gzip_work = _gzip_zip;
#ifdef	DEBUG
	{
		int	i;
		for (i = SLAVE_STACK_SIZE; --i >= 0; slave_stack[i] = 0);
	}
#endif

	/* [hݒ */
	mode =  O_WRONLY | O_BINARY | O_TRUNC | O_CREAT;

	fd = CREATE(file, mode);

#ifdef	DEBUG
	fprintf(stderr, "stack check 1465=%08x, 1466=%08x, 1467=%08x, 1468=%08x\n",
		slave_stack[1465], slave_stack[1466], slave_stack[1467], slave_stack[1468]);
#endif
	return (fd == -1 ? -1 : biased(fd));
}


int	_slave_read(int fd, char* buf, size_t siz)
{
#ifdef	DEBUG
	fprintf(stderr, "%20s(fd=%x, buf=%p, siz=%d(%x))\n", "_slave_read", fd, buf, siz, siz);
	fprintf(stderr, "stack master=%06x, slave=%06x\n", main_sp, slave_sp);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

	/* Xbht@CfBXNv^ */
	if (!_isthread(fd)) return -1;

	slave_siz = slave_cnt = siz;
	if ((slave_ptr = buf) == 0) dispatch_to_main();
	if (siz == 0) return 0;

	do {

		/* obt@Ƀf[^邩 */
		if (main_cnt > 0) {

			/* ǂ݂ʂf[^ */
			if (main_cnt >= slave_cnt) {
				memcpy((PTR)slave_ptr, (CONST PTR)main_ptr, slave_cnt);
				main_ptr += slave_cnt;
				main_cnt -= slave_cnt;

				/*
				 *	C̏݃TCYobt@̔{ł
				 *	main_cnt >= slave_cnt ̏X[u͓ǂݏo
				 */
				return siz;
			}

			/* f[^Săobt@ɓǂݍ߂ */
#ifdef	DEBUG
			fprintf(stderr, "main_cnt=%x\n", main_cnt);
#endif
			memcpy((PTR)slave_ptr, (CONST PTR)main_ptr, main_cnt);
			slave_ptr += main_cnt;
			slave_cnt -= main_cnt;
			main_cnt = 0;
		}

		/* main  block Ăꏊɖ߂ */
		dispatch_to_main();

		/* obt@tbV */
		if (main_cnt == 0) break;

	} while (slave_cnt > 0);

#ifdef	DEBUG
		fprintf(stderr, "slave_siz=%x, slave_cnt=%x\n", slave_siz, slave_cnt);
#endif
	return slave_siz - slave_cnt;
}


static void	slave_write_main()
{
	(*_gzip_work)(biased(slave_fd), slave_fd);
	for (;;) {
		_slave_read(biased(slave_fd), (char*)0, 0);
	}
}


int	_thread_write(int fd, char* buf, int siz)
{
#ifdef	DEBUG
	fprintf(stderr, "%20s(fd=%x, buf=%p, siz=%d(%x))\n", "_thread_write", fd, buf, siz, siz);
	fprintf(stderr, "stack master=%06x, slave=%06x\n", main_sp, slave_sp);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

	/* Xbht@CfBXNv^ */
	if (!_isthread(fd)) return -1;

	/* f[^ɕϊ */
	main_ptr = buf;
	if ((main_cnt = siz) == 0) return 0;

	/* V[N|C^i߂ */
	main_lseek_pos += (long)siz;

	/* Xbh͋Nς */
	if (slave_started == 0) {
		slave_started = 1;
		slave_fd = realized(fd);
		slave_write_start();

		/* slave_cnt <= 0 ȂΈُI */
		if (slave_cnt < 0) return -1;

		/* X[u̓dĂт */
		if (slave_cnt == 0) return siz - main_cnt;
	}

	do {
		/* ނׂf[^obt@ɂ邩 */
		if (slave_cnt > 0) {

			/* vʂobt@f[^ʂ */
			if (slave_cnt >= main_cnt) {
				memcpy((PTR)slave_ptr, (CONST PTR)main_ptr, main_cnt);
				slave_ptr += main_cnt;
				slave_cnt -= main_cnt;	/* slave_cnt == 0 ̉\邱Ƃɒ */
				return siz;
			}

		}

		/* thread  block Ăꏊɖ߂ */
		dispatch_to_slave();

		/* X[uŃG[ */
		if (slave_cnt == -1) return -1;

		/* obt@O */
		if (main_cnt == 0) break;

	} while (slave_cnt > 0);

	return siz - main_cnt;
}


long _thread_lseek(int fd, long offset, int origin)
{
	if (!_isthread(fd)) return -1;

	switch (origin) {
	case 0:
		if (offset == main_lseek_pos) return main_lseek_pos;
		break;
	case 1:
		if (offset == 0L) return main_lseek_pos;
		break;
	}
	return -1;
}


int	_thread_close(int fd)
{
#ifdef	DEBUG
	fprintf(stderr, "%20s(fd=%x)\n", "_thread_close", fd);
	fprintf(stderr, "stack master=%06x, slave=%06x\n", main_sp, slave_sp);
#if	0
	fprintf(stderr, "slave_stack[1466](%06x)=%08x\n",
		slave_stack+1466, slave_stack[1466]);
#endif
#endif

	if (!_isthread(fd)) return -1;

#ifdef	CHECK_THREAD_BUSY
	/* ĂяoĂȂꍇ̓G[ */
	if (thread_busy == 0) return -1;
#endif

	/* obt@Ƀf[^cĂ邩 */
	if (slave_siz != slave_cnt) {
		main_cnt = 0;
		dispatch_to_slave();
		if (slave_siz) {
			main_cnt = 0;
			dispatch_to_slave();
		}
	}
#ifdef	CHECK_SLAVE_STACK
	{
		int	i;

		for (i = 0; slave_stack[i] == 0; i++) ;
		fprintf(stderr, "stack free=%d(%d%%)\n", i, (100*i)/SLAVE_STACK_SIZE);
	}
#endif

#ifdef	CHECK_THREAD_BUSY
	/* XbhI */
	thread_busy = 0;
#endif

	return close(realized(fd));
}


/*
 *	XbhfBXpb`[` slave -> main
 */
static void	dispatch_to_main(void)
{
	asm("movem.l\td3-d7/a3-a6,-(sp)"::);
#if	0
	asm("move.l\tsp,%0":/*No output*/:"m"(slave_sp));
	asm("move.l\t%0,sp":/*No output*/:"m"(main_sp));
#else
	asm("move.l\tsp,_slave_sp":/*No output*/:);
	asm("move.l\t_main_sp,sp":/*No output*/:);
#endif
	asm("movem.l\t(sp)+,d3-d7/a3-a6"::);
}

/*
 *	XbhfBXpb`[` main -> slave
 */
static void	dispatch_to_slave(void)
{
	asm("movem.l\td3-d7/a3-a6,-(sp)"::);
#if	0
	asm("move.l\tsp,%0":/*No output*/:"m"(main_sp));
	asm("move.l\t%0,sp":/*No output*/:"m"(slave_sp));
#else
	asm("move.l\tsp,_main_sp":/*No output*/:);
	asm("move.l\t_slave_sp,sp":/*No output*/:);
#endif
	asm("movem.l\t(sp)+,d3-d7/a3-a6"::);
}

static void slave_read_start(void)
{
	asm("movem.l\td3-d7/a3-a6,-(sp)"::);
#if	0
	asm("move.l\tsp,%0":/*No output*/:"m"(main_sp));
	asm("move.l\t%0,sp":/*No output*/:"m"(slave_sp));
#else
	asm("move.l\tsp,_main_sp":/*No output*/:);
	asm("move.l\t_slave_sp,sp":/*No output*/:);
#endif
	asm("jmp\t(%0)":/*No output*/:"a"(slave_read_main));
}

static void slave_write_start(void)
{
	asm("movem.l\td3-d7/a3-a6,-(sp)"::);
#if	0
	asm("move.l\tsp,%0":/*No output*/:"m"(main_sp));
	asm("move.l\t%0,sp":/*No output*/:"m"(slave_sp));
#else
	asm("move.l\tsp,_main_sp":/*No output*/:);
	asm("move.l\t_slave_sp,sp":/*No output*/:);
#endif
	asm("jmp\t(%0)":/*No output*/:"a"(slave_write_main));
}


/* EOF */
